IF EXISTS(SELECT NAME
            FROM SYSOBJECTS
           WHERE NAME = 'CTB_REC_LANC' AND TYPE = 'P')
   DROP PROCEDURE CTB_REC_LANC
GO

CREATE PROCEDURE CTB_REC_LANC
   @P_NRLANCCTBTEMP  VARCHAR(12),
   @P_CDFILIAL       VARCHAR(04),
   @P_NRLANCTONF     VARCHAR(10),
   @P_NRPARCELAREC   VARCHAR(02),
   @P_NRSEQVENREC    VARCHAR(02),
   @P_DTAJUSTEREC    DATETIME,
   @P_CDAJUCTREC     VARCHAR(04),
   @P_IDTIPO         VARCHAR(01),
   @P_NRLANCCTB      VARCHAR(12) OUTPUT
AS
   /* VARIAVEIS DO CURSOR C_CONTAS */
   DECLARE @C_CONTAS_CDEMPRESA VARCHAR(02);
   DECLARE @C_CONTAS_CDTPCTRECEB VARCHAR(06);
   DECLARE @C_CONTAS_CDFILIEMIT VARCHAR(04);
   DECLARE @C_CONTAS_CDCLIENTE VARCHAR(21);
   DECLARE @C_CONTAS_NRNOTAFISC VARCHAR(20);
   DECLARE @C_CONTAS_DTEMISSAO DATETIME;
   DECLARE @C_CONTAS_VRATUAREC FLOAT;
   DECLARE @C_CONTAS_IDSTATUS VARCHAR(01);
   DECLARE @C_CONTAS_CDHISTPADR VARCHAR(04);
   DECLARE @C_CONTAS_CDCONTCTBL VARCHAR(20);

   DECLARE @V_CONTRAT VARCHAR(01);
   DECLARE @V_NRLANCTEMP VARCHAR(20);

   DECLARE @V_DATAAUX VARCHAR(20);
   DECLARE @V_CDHISTPADR VARCHAR(04);
   DECLARE @V_DSHISTLANC VARCHAR(200);
   DECLARE @V_CDCONTCTBL VARCHAR(20);
   DECLARE @V_IDTIPOCOME VARCHAR(01);
   DECLARE @V_IDCONTCCUS VARCHAR(01);
   DECLARE @V_CDCLIENTEAUX VARCHAR(21);

   DECLARE @V_CDCENTCUST VARCHAR(04);
   DECLARE @V_CDFILIAL VARCHAR(04);
   DECLARE @V_VRRATEIO FLOAT;
   DECLARE @V_RATSEQ INT;
   DECLARE @V_ENTROULOOP VARCHAR(01);

   /* VARIAVEIS DO CURSOR @C_RATTIPOCONTA */
   DECLARE @C_RATTIPOCONTA_CDCENTCUST   VARCHAR(04);
   DECLARE @C_RATTIPOCONTA_CDFIRATTPCTR VARCHAR(04);
   DECLARE @C_RATTIPOCONTA_CDFILIAL     VARCHAR(04)
   DECLARE @C_RATTIPOCONTA_VRPERATTPCTR FLOAT;

   DECLARE @V_RATSEQAUX VARCHAR(05);
   DECLARE @V_COUNT INT;

   /* VARIAVEIS DO CURSOR AJUSTE */
   DECLARE @AJUSTE_CDFILIAL VARCHAR(04);
   DECLARE @AJUSTE_NRLANCTONF VARCHAR(10);
   DECLARE @AJUSTE_NRSEQVENREC VARCHAR(02);
   DECLARE @AJUSTE_NRPARCELAREC VARCHAR(02);
   DECLARE @AJUSTE_DTAJUSTEREC DATETIME;
   DECLARE @AJUSTE_CDAJUCTREC VARCHAR(04);
   DECLARE @AJUSTE_DSAJUCTREC VARCHAR(20);
   DECLARE @AJUSTE_CDHISTPADR VARCHAR(04);
   DECLARE @AJUSTE_VRAJUSTEREC FLOAT;
   DECLARE @AJUSTE_IDAJUCTREC VARCHAR(01);
   DECLARE @AJUSTE_CDCONTCTBL VARCHAR(20);
   DECLARE @AJUSTE_CDCLIENTE VARCHAR(21);
   DECLARE @AJUSTE_CDFILIEMIT VARCHAR(04);

   DECLARE @V_FATOR INT;

  /* VARIAVEIS DO CURSOR RATAJU */
  DECLARE @RATAJU_CDCENTCUST VARCHAR(04);
  DECLARE @RATAJU_CDFIRATTPAJR VARCHAR(04);
  DECLARE @RATAJU_CDFILIAL VARCHAR(04);
  DECLARE @RATAJU_VRPERATTPAJR FLOAT;

  DECLARE @V_VRPARTIDA FLOAT;
  DECLARE @V_VRRAT FLOAT;

BEGIN
   DECLARE C_CONTAS CURSOR FOR
      SELECT CR.CDEMPRESA, CR.CDTPCTRECEB, NF.CDFILIEMIT, NF.CDCLIENTE,
             NF.NRNOTAFISC, NF.DTEMISSAO, CR.VRATUAREC, NF.IDSTATUS,
             TP.CDHISTPADR, TP.CDCONTCTBL
        FROM CONTARECEBER CR, NOTAFISCAL NF, TIPOCTRECEBER TP LEFT JOIN HISTPADR H
                                                                     ON TP.CDHISTPADR = H.CDHISTPADR
       WHERE CR.CDFILIAL = @P_CDFILIAL
         AND CR.NRLANCTONF = @P_NRLANCTONF
         AND CR.NRSEQVENREC = @P_NRSEQVENREC
         AND CR.NRPARCELAREC = @P_NRPARCELAREC
         AND CR.CDFILIAL = NF.CDFILIAL
         AND CR.NRLANCTONF = NF.NRLANCTONF
         AND CR.CDTPCTRECEB = TP.CDTPCTRECEB
         AND TP.IDCTBLCTREC = 'S';
   OPEN C_CONTAS;
   FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDEMPRESA, @C_CONTAS_CDTPCTRECEB, @C_CONTAS_CDFILIEMIT, @C_CONTAS_CDCLIENTE,
                                @C_CONTAS_NRNOTAFISC, @C_CONTAS_DTEMISSAO, @C_CONTAS_VRATUAREC, @C_CONTAS_IDSTATUS,
                                @C_CONTAS_CDHISTPADR, @C_CONTAS_CDCONTCTBL;
   WHILE @@FETCH_STATUS = 0 BEGIN
      /* VERIFICA SE A EMPRESA RESPONSVEL PELA CONTA UTILIZA A  GEREO DE RATEIO DO LANAMENTO CONTBIL  N- NO S-SIM
         VERIFICA SE OS VALORES DE PARTIDAS IRO ACUMULAR, CASO A CONTA CONTBIL SEJA A MESMA*/
      SELECT @V_CONTRAT = IDCONTGERE
        FROM CONTOPECTBL
       WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA;
      IF @P_NRLANCCTBTEMP IS NOT NULL BEGIN
         /* DELETA OS RATEIOS DO LANAMENTO CONTBIL */
         DELETE
           FROM LANCCCUSTO
          WHERE NRLANCCONT = @P_NRLANCCTBTEMP
            AND CDEMPRESA  = @C_CONTAS_CDEMPRESA;

         /* DELETA AS PARTIDAS DO LANAMENTO CONTBIL */
         DELETE
           FROM LANCCONT
          WHERE NRLANCCONT = @P_NRLANCCTBTEMP
            AND CDEMPRESA  = @C_CONTAS_CDEMPRESA;

      END;
      SET @V_NRLANCTEMP = @P_NRLANCCTBTEMP;

      SELECT @V_COUNT = COUNT(*)
        FROM PARAMCTBL
       WHERE @C_CONTAS_DTEMISSAO >= DTINTCTBREC;

      IF @V_COUNT > 0 BEGIN
         IF @C_CONTAS_IDSTATUS = 'A' BEGIN
            /* DELETA TODOS OS REGISTROS TEMPORRIOS PARA ESSE LANAMENTO */
            DELETE FROM LANCCTBTEMP
             WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
               AND CDEMPRESA     = @C_CONTAS_CDEMPRESA;

            DELETE FROM RATECTBTEMP
             WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
               AND CDEMPRESA     = @C_CONTAS_CDEMPRESA;

            IF @P_IDTIPO = 'D' BEGIN

               /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
               IF @V_NRLANCTEMP IS NULL BEGIN
                  /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO REC SEJA NOVO */
                  SET @V_DATAAUX = CONVERT(VARCHAR, @C_CONTAS_DTEMISSAO, 103);
                  SET @V_DATAAUX = 'LANCCONTABIL' + @C_CONTAS_CDEMPRESA + SUBSTRING(@V_DATAAUX, 7, 4) + SUBSTRING(@V_DATAAUX, 4, 2);

                  EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;

                  SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @C_CONTAS_DTEMISSAO, 103), 7, 4);
                  SET @V_DATAAUX = @V_DATAAUX + SUBSTRING(CONVERT(VARCHAR, @C_CONTAS_DTEMISSAO, 103), 4, 2);

                  SET @V_NRLANCTEMP = @V_DATAAUX  + SUBSTRING(@V_NRLANCTEMP, 15, 6);
               END;

               /* BUSCA HISTORICO PADRAO DE INTEGRAO DO REC*/
               SELECT @V_CDHISTPADR = HI.CDHISTPADR
                 FROM HISTINTEGRA HI, HISTPADR HP
                WHERE HI.CDHISTPADR = HP.CDHISTPADR
                  AND HI.CDOPERACAO = 'CTAREC';

               /* VERIFICA SE EXISTE HISTORIO CADASTRADO NO TIPO DE CONTA, CASO NO EXISTA PEGA DO HISTORICO DE INTEGRAO REC */
               IF @C_CONTAS_CDHISTPADR IS NOT NULL BEGIN
                  SET @V_CDHISTPADR = @C_CONTAS_CDHISTPADR;
               END;

               /* FORMATA A DESCRIO DO HISTRICO PADRO BUSCADO, DO TIPO DE CONTA OU DE INTEGRAO */
               EXEC CTB_HIST_REC @V_CDHISTPADR, @P_CDFILIAL, @P_NRLANCTONF, @P_NRSEQVENREC, @P_NRPARCELAREC, @P_CDAJUCTREC, @P_DSHISTPADR = @V_DSHISTLANC OUTPUT;

               /* DEBITA NA CONTA CONTABIL DE CLIENTE */
               EXEC CTB_CCCLIENTE @C_CONTAS_CDCLIENTE, @C_CONTAS_CDFILIEMIT, @C_CONTAS_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;

               SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               SET @V_CDCLIENTEAUX = @C_CONTAS_CDCLIENTE;
               IF @V_IDTIPOCOME <> 'C' BEGIN
                  SET @V_CDCLIENTEAUX = NULL;
                  SET @V_IDTIPOCOME   = 'N';
               END;

               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00001', @V_CDCONTCTBL, @V_CDHISTPADR,
                   @V_DSHISTLANC, @C_CONTAS_DTEMISSAO, @C_CONTAS_VRATUAREC * -1, @V_IDTIPOCOME, @V_CDCLIENTEAUX, 'REC');

               /* VERIFICA SE A EMPRESA GERA O RATEIO CONTBIL. */
               IF @V_CONTRAT = 'S' BEGIN
                  /* VERIFICA SE A CONTA NO  "S OFICIAL"*/
                  IF @V_IDCONTCCUS <> 'O' BEGIN
                     SELECT @V_CDCENTCUST = CDCENTCUST
                       FROM FILIAL
                      WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                     IF @V_CDCENTCUST IS NULL BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM EMPRESA
                         WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                     END;
                     INSERT INTO RATECTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                     VALUES
                        (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00001', @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST, @C_CONTAS_VRATUAREC * -1, @C_CONTAS_DTEMISSAO, '00001');
                  END;
               END;

               SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @C_CONTAS_CDCONTCTBL;

               SET @V_CDCLIENTEAUX = @C_CONTAS_CDCLIENTE;

               /*VERIFICA O TIPO DE CDIGO COMERCIAL, CASO SEJA DIFERENTE DE CLIENTE,  PASSADO NULO PARA A PARTIDA.
               O N  TRATADO NA HORA DE PASSAR PARA A LANCCONT NA PROCEDURE GRAVA_LANC_CTB */
               IF @V_IDTIPOCOME <> 'C' BEGIN
                  SET @V_CDCLIENTEAUX = NULL;
                  SET @V_IDTIPOCOME   = 'N';
               END;

               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00002', @C_CONTAS_CDCONTCTBL, @V_CDHISTPADR,
                   @V_DSHISTLANC, @C_CONTAS_DTEMISSAO, @C_CONTAS_VRATUAREC, @V_IDTIPOCOME, @V_CDCLIENTEAUX, 'REC');

               IF @V_CONTRAT = 'S' BEGIN
                  IF @V_IDCONTCCUS <> 'O' BEGIN
                     SET @V_VRRATEIO = 0;
                     SET @V_RATSEQ = 1;
                     SET @V_ENTROULOOP = 'N';

                     DECLARE C_RATTIPOCONTA CURSOR FOR
                        SELECT CDCENTCUST, CDFIRATTPCTR, CDFILIAL, VRPERATTPCTR
                          FROM RATTPCTR
                         WHERE CDTPCTRECEB = @C_CONTAS_CDTPCTRECEB;

                     OPEN C_RATTIPOCONTA;
                     FETCH NEXT FROM C_RATTIPOCONTA INTO @C_RATTIPOCONTA_CDCENTCUST, @C_RATTIPOCONTA_CDFIRATTPCTR,
                                                          @C_RATTIPOCONTA_CDFILIAL, @C_RATTIPOCONTA_VRPERATTPCTR;
                     WHILE @@FETCH_STATUS = 0 BEGIN
                        SET @V_ENTROULOOP = 'S';

                        /* FAZ O SOMATRIO DOS VALORES RATEADOS PARA VER SE DA DIFERENA DE ARREDONDAMENTO NO FINAL */
                        SET @V_VRRATEIO = @V_VRRATEIO + ROUND((@C_CONTAS_VRATUAREC * @C_RATTIPOCONTA_VRPERATTPCTR) / 100, 2);

                        /* SE O RATEIO PADRONIZADO TIVER FILIAL PREENCHIDA FAZ O RATEIO PARA A FILIAL CADASTRADA */
                        IF @C_RATTIPOCONTA_CDFIRATTPCTR IS NOT NULL BEGIN
                           IF @C_RATTIPOCONTA_CDFIRATTPCTR = '----' BEGIN
                              SET @V_CDFILIAL = @C_CONTAS_CDFILIEMIT;
                           END
                           ELSE BEGIN
                              SET @V_CDFILIAL = @C_RATTIPOCONTA_CDFIRATTPCTR;
                           END;

                           SET @V_CDCENTCUST = @C_RATTIPOCONTA_CDCENTCUST;

                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);

                           SET @V_VRRAT = ROUND((@C_CONTAS_VRATUAREC * @C_RATTIPOCONTA_VRPERATTPCTR)/100, 2);
                           INSERT INTO RATECTBTEMP
                              (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @V_CDFILIAL, @C_RATTIPOCONTA_CDCENTCUST,
                               @V_VRRAT, @C_CONTAS_DTEMISSAO, @V_RATSEQAUX);
                           SET @V_RATSEQ = @V_RATSEQ + 1;
                        END;
                        FETCH NEXT FROM C_RATTIPOCONTA INTO @C_RATTIPOCONTA_CDCENTCUST, @C_RATTIPOCONTA_CDFIRATTPCTR,
                                                          @C_RATTIPOCONTA_CDFILIAL, @C_RATTIPOCONTA_VRPERATTPCTR;
                     END;
                     CLOSE C_RATTIPOCONTA;
                     DEALLOCATE C_RATTIPOCONTA;
                     IF @V_ENTROULOOP = 'N' BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                        END;
                        SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST,
                            @C_CONTAS_VRATUAREC, @C_CONTAS_DTEMISSAO, @V_RATSEQAUX);
                     END;

                     /* VERIFICA SE O VALOR TOTAL RATEADO  IGUAL AO VALOR DA CONTA. CASO NO SEJA, 
                        FEITO O RATEIO PARA A LTIMA FILAL E CENTRO DE CUSTO RATEADO */
                     IF @V_VRRATEIO <> @C_CONTAS_VRATUAREC BEGIN
                        SET @V_VRRATEIO = @V_VRRATEIO - @C_CONTAS_VRATUAREC;
                        IF @V_VRRATEIO > 0 BEGIN
                           SET @V_VRRATEIO = - @V_VRRATEIO;
                        END;
                        UPDATE RATECTBTEMP
                           SET VRRATECTBTEMP = VRRATECTBTEMP + @V_VRRATEIO
                         WHERE CDEMPRESA     = @C_CONTAS_CDEMPRESA
                           AND NRLANCCTBTEMP = @V_NRLANCTEMP
                           AND NRSEQCTBTEMP  = '00002'
                           AND CDFILIAL      = @V_CDFILIAL
                           AND CDCENTCUST    = @V_CDCENTCUST;
                     END;
                  END;
               END;

               /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
               EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;

               SELECT @V_COUNT = ISNULL(COUNT(*), 0)
                 FROM ERROCTBTEMP
                WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                  AND NRLANCCTBTEMP = @V_NRLANCTEMP;
               /* SE O LANAMENTO NO TER ERROS,  GRAVADO O NMERO DE LANAMENTO CONTBIL NA NOTA FISCAL */
               IF @V_COUNT = 0 BEGIN
                  UPDATE NOTAFISCAL
                     SET NRLANCTBDOC = @V_NRLANCTEMP
                   WHERE NRLANCTONF  = @P_NRLANCTONF
                     AND CDFILIAL    = @P_CDFILIAL;
               END;

            END
            ELSE IF @P_IDTIPO = 'A' BEGIN
               /*----------------------------------------------------------------------*/
               /* Contabilizao de ajuste da aba ajuste da tela de contas a a receber */
               /*----------------------------------------------------------------------*/

               /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
               IF @V_NRLANCTEMP IS NULL BEGIN
                  /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O AJUSTE NO REC SEJA NOVO */
                  SET @V_DATAAUX = CONVERT(VARCHAR, @P_DTAJUSTEREC, 103);
                  SET @V_DATAAUX = 'LANCCONTABIL' + @C_CONTAS_CDEMPRESA + SUBSTRING(@V_DATAAUX, 7, 4) + SUBSTRING(@V_DATAAUX, 4, 2);

                  EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;

                  SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @P_DTAJUSTEREC, 103), 7, 4);
                  SET @V_DATAAUX = @V_DATAAUX + SUBSTRING(CONVERT(VARCHAR, @P_DTAJUSTEREC, 103), 4, 2);

                  SET @V_NRLANCTEMP = @V_DATAAUX  + SUBSTRING(@V_NRLANCTEMP, 15, 6);

               END;

               DECLARE AJUSTE CURSOR FOR
                  SELECT A.CDFILIAL, A.NRLANCTONF, A.NRSEQVENREC, A.NRPARCELAREC,
                         A.DTAJUSTEREC, A.CDAJUCTREC, T.DSAJUCTREC, T.CDHISTPADR,
                         ROUND(A.VRAJUSTEREC, 2) VRAJUSTEREC, T.IDAJUCTREC, T.CDCONTCTBL,
                         NF.CDCLIENTE, NF.CDFILIEMIT
                   FROM AJCTRECEBER A, NOTAFISCAL NF, TIPOAJRECEBER T LEFT JOIN HISTPADR H
                                                                             ON T.CDHISTPADR = H.CDHISTPADR
                  WHERE A.CDFILIAL = @P_CDFILIAL
                    AND A.NRLANCTONF = @P_NRLANCTONF
                    AND A.NRSEQVENREC = @P_NRSEQVENREC
                    AND A.NRPARCELAREC = @P_NRPARCELAREC
                    AND A.DTAJUSTEREC = @P_DTAJUSTEREC
                    AND A.CDAJUCTREC = @P_CDAJUCTREC
                    AND A.CDAJUCTREC = T.CDAJUCTREC
                    AND NF.CDFILIAL = A.CDFILIAL
                    AND NF.NRLANCTONF = A.NRLANCTONF
                  ORDER BY A.CDFILIAL, A.NRLANCTONF, A.CDAJUCTREC;
               OPEN AJUSTE;
               FETCH NEXT FROM AJUSTE INTO @AJUSTE_CDFILIAL, @AJUSTE_NRLANCTONF, @AJUSTE_NRSEQVENREC, @AJUSTE_NRPARCELAREC,
                                           @AJUSTE_DTAJUSTEREC, @AJUSTE_CDAJUCTREC, @AJUSTE_DSAJUCTREC, @AJUSTE_CDHISTPADR,
                                           @AJUSTE_VRAJUSTEREC, @AJUSTE_IDAJUCTREC, @AJUSTE_CDCONTCTBL, @AJUSTE_CDCLIENTE,
                                           @AJUSTE_CDFILIEMIT;
               WHILE @@FETCH_STATUS = 0 BEGIN
                  /* VERIFICA SE  UM AJUSTE DE DESCONTO OU ACRSCIMO */
                  IF @AJUSTE_IDAJUCTREC = 'D' BEGIN
                     SET @V_FATOR = -1;
                  END
                  ELSE BEGIN
                     SET @V_FATOR = 1;
                  END;

                  SET @V_CDHISTPADR = @AJUSTE_CDHISTPADR;

                  EXEC CTB_HIST_REC @V_CDHISTPADR, @P_CDFILIAL, @P_NRLANCTONF, @P_NRSEQVENREC, @P_NRPARCELAREC, @P_CDAJUCTREC, @P_DSHISTPADR = @V_DSHISTLANC OUTPUT;

                  EXEC CTB_CCCLIENTE @C_CONTAS_CDCLIENTE, @C_CONTAS_CDFILIEMIT, @C_CONTAS_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;

                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  SET @V_CDCLIENTEAUX = @C_CONTAS_CDCLIENTE;

                  /* CASO A CONTA CONTBIL NO SEJA DO TIPO CLIENTE, A PARTIDA SER SEM CIDGO COMERCIAL */
                  IF @V_IDTIPOCOME <> 'C' BEGIN
                     SET @V_CDCLIENTEAUX = NULL;
                     SET @V_IDTIPOCOME = 'N';
                  END;

                  SET @V_VRPARTIDA = @AJUSTE_VRAJUSTEREC * -1 * @V_FATOR;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00001', @V_CDCONTCTBL, @V_CDHISTPADR,
                      @V_DSHISTLANC, @AJUSTE_DTAJUSTEREC, @V_VRPARTIDA, @V_IDTIPOCOME, @V_CDCLIENTEAUX, 'REC');

                  /* VERIFICA SE A EMPRESA CONTROLA O RATEIO CONTBIL */
                  IF @V_CONTRAT = 'S' BEGIN
                     /* VERIFICA SE A CONTA CONTBIL NO  "S OFICIAL" */
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                        END;
                        SET @V_VRRAT = @AJUSTE_VRAJUSTEREC * @V_FATOR * -1;
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00001', @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST, @V_VRRAT, @AJUSTE_DTAJUSTEREC, '00001');
                     END;
                  END;

                  /* DEBITA NO TIPO DE AJUSTE */
                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  /* GUARDA O CDIGO DO CLIENTE */
                  SET @V_CDCLIENTEAUX = @AJUSTE_CDCLIENTE;

                  /* SE A CONTA CONTBIL FOR DIFERENTE DE CLIENTE,  FEITA A PARTIDA SEM CDIGO COMERCIAL */
                  IF @V_IDTIPOCOME <> 'C' BEGIN
                     SET @V_IDTIPOCOME = 'N';
                     SET @V_CDCLIENTEAUX = NULL;
                  END;

                  SET @V_VRPARTIDA = @AJUSTE_VRAJUSTEREC * @V_FATOR;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00002', @AJUSTE_CDCONTCTBL, @V_CDHISTPADR,
                      @V_DSHISTLANC, @AJUSTE_DTAJUSTEREC, @V_VRPARTIDA, @V_IDTIPOCOME, @V_CDCLIENTEAUX, 'REC');

                  /* VERIFICA SE A EMPRESA CONTROLA RATEIO CONTBIL */
                  IF @V_CONTRAT = 'S' BEGIN
                     /* SE A CONTA CONTBIL FOR DIFERENTE DE "S OFICIAL", SO FEITOS OS RATEIOS NECESSRIOS */
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        SET @V_ENTROULOOP = 'N';
                        SET @V_RATSEQ = 1;

                        SET @V_VRRATEIO = 0;
                        /* PEGA OS CENTROS DE CUSTOSM FILIALS E PERCENTUAIS CADASTRADOS NA TELA */
                        DECLARE RATAJU CURSOR FOR
                           SELECT CDCENTCUST, CDFIRATTPAJR, CDFILIAL, VRPERATTPAJR
                              FROM RATTPAJR
                             WHERE CDAJUCTREC = @P_CDAJUCTREC;
                        OPEN RATAJU;
                        FETCH NEXT FROM RATAJU INTO @RATAJU_CDCENTCUST, @RATAJU_CDFIRATTPAJR,
                                                    @RATAJU_CDFILIAL, @RATAJU_VRPERATTPAJR;

                        WHILE @@FETCH_STATUS = 0 BEGIN
                           SET @V_ENTROULOOP = 'S';

                           /* FAZ O SOMATRIO DOS RATEIOS DE ACORDO COM OS PERCENTUAIS INFORMADOS NA TELA
                              PARA VERIFICAR SE EXISTE DIFERENA DE ARREDONDAMENTO POSTERIORMENTE */
                           SET @V_VRRATEIO = @V_VRRATEIO + ROUND(((@AJUSTE_VRAJUSTEREC * @V_FATOR)* @RATAJU_VRPERATTPAJR) /100, 2);
                           SET @V_VRRAT = ROUND(((@AJUSTE_VRAJUSTEREC * @V_FATOR)* @RATAJU_VRPERATTPAJR) /100, 2);

                           IF @RATAJU_CDFIRATTPAJR = '----' BEGIN
                              SET @V_CDFILIAL = @AJUSTE_CDFILIEMIT;
                           END
                           ELSE BEGIN
                              SET @V_CDFILIAL = @RATAJU_CDFIRATTPAJR;
                           END;

                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           /* CASO TENHA FILIAL CADASTRADA NA TELA,  FEITO O RATEIO PARA ESSA FILIAL */
                           INSERT INTO RATECTBTEMP
                             (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @V_CDFILIAL, @RATAJU_CDCENTCUST,
                               @V_VRRAT, @AJUSTE_DTAJUSTEREC, @V_RATSEQAUX);

                           SET @V_CDCENTCUST = @RATAJU_CDCENTCUST;
                           SET @V_RATSEQ = @V_RATSEQ + 1;

                           FETCH NEXT FROM RATAJU INTO @RATAJU_CDCENTCUST, @RATAJU_CDFIRATTPAJR,
                                                       @RATAJU_CDFILIAL, @RATAJU_VRPERATTPAJR;
                        END;
                        CLOSE RATAJU;
                        DEALLOCATE RATAJU;

                        IF @V_ENTROULOOP = 'S' BEGIN
                           /* VERIFICA SE O VALOR TOTAL RATEADO  IGUAL AO VEALOR DO AJUSTE, CASO NO SEJA,  FEITO
                              O RATEIO PARA A LTIMA FILIAL E CENTRO DE CUSTO */
                           IF @V_VRRATEIO <> (@AJUSTE_VRAJUSTEREC * @V_FATOR) BEGIN
                              SET @V_VRRATEIO = (@AJUSTE_VRAJUSTEREC * @V_FATOR) - @V_VRRATEIO;
                              UPDATE RATECTBTEMP
                                 SET VRRATECTBTEMP = VRRATECTBTEMP + @V_VRRATEIO
                               WHERE CDEMPRESA     = @C_CONTAS_CDEMPRESA
                                 AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                 AND NRSEQCTBTEMP  = '00002'
                                 AND CDFILIAL      = @V_CDFILIAL
                                 AND CDCENTCUST    = @V_CDCENTCUST;
                           END;
                        END;

                        IF @V_ENTROULOOP = 'N' BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM FILIAL
                            WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                           IF @V_CDCENTCUST IS NULL BEGIN
                              SELECT @V_CDCENTCUST = CDCENTCUST
                                FROM EMPRESA
                               WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                           END;
                           /* CASO NO TENHA RATEIO CADASTRADO NA TELA DE PARAMETROS PARA CENTRO DE CUSTO,  FEITO O RATEIO
                              PARA A FILIAL DE EMISSO DA CONTA DO AJUSTE */
                           SET @V_VRRAT = ROUND(@AJUSTE_VRAJUSTEREC * @V_FATOR, 2);
                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           INSERT INTO RATECTBTEMP
                             (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST,
                              @V_VRRAT, @AJUSTE_DTAJUSTEREC, @V_RATSEQAUX);
                        END
                     END;
                  END;

                  FETCH NEXT FROM AJUSTE INTO @AJUSTE_CDFILIAL, @AJUSTE_NRLANCTONF, @AJUSTE_NRSEQVENREC, @AJUSTE_NRPARCELAREC,
                                              @AJUSTE_DTAJUSTEREC, @AJUSTE_CDAJUCTREC, @AJUSTE_DSAJUCTREC, @AJUSTE_CDHISTPADR,
                                              @AJUSTE_VRAJUSTEREC, @AJUSTE_IDAJUCTREC, @AJUSTE_CDCONTCTBL, @AJUSTE_CDCLIENTE,
                                              @AJUSTE_CDFILIEMIT;
               END;
               CLOSE AJUSTE;
               DEALLOCATE AJUSTE;
               /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
               EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;
               SELECT @V_COUNT = COUNT(*)
                 FROM ERROCTBTEMP
                WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                  AND CDEMPRESA = @C_CONTAS_CDEMPRESA;

               /* CASO NO TENHA GERADO ERRO NA ROTINA DE CONTABILIZAO, O NMERO DE LANAMENTO  GRAVADO NO AJUSTE. */
               IF @V_COUNT = 0 BEGIN
                  IF @P_NRLANCCTBTEMP IS NULL BEGIN
                     UPDATE AJCTRECEBER
                        SET NRLCTBAJREC = @V_NRLANCTEMP
                      WHERE CDFILIAL     = @P_CDFILIAL
                        AND NRLANCTONF   = @P_NRLANCTONF
                        AND NRSEQVENREC  = @P_NRSEQVENREC
                        AND NRPARCELAREC = @P_NRPARCELAREC
                        AND DTAJUSTEREC  = @P_DTAJUSTEREC
                        AND CDAJUCTREC   = @P_CDAJUCTREC;
                  END;
               END;
            END;
         END;

         SET @P_NRLANCCTB = @V_NRLANCTEMP;
         /* TRMINO DAS PARTIDAS DO LANCAMENTO CONTABIL*/
          /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
         EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;
      END;
      FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDEMPRESA, @C_CONTAS_CDTPCTRECEB, @C_CONTAS_CDFILIEMIT, @C_CONTAS_CDCLIENTE,
                                   @C_CONTAS_NRNOTAFISC, @C_CONTAS_DTEMISSAO, @C_CONTAS_VRATUAREC, @C_CONTAS_IDSTATUS,
                                   @C_CONTAS_CDHISTPADR, @C_CONTAS_CDCONTCTBL;
   END;
   CLOSE C_CONTAS;
   DEALLOCATE C_CONTAS;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'CTB_REC_LANC','5.50.000';
GO

